<template>
  <ObModal
    ref="modal"
    :title="title"
    :is-show-controls="false"
    size="medium"
  >
    <div class="scenario-modal">
      <div
        v-if="isGoingToQuit"
        class="save-modal-warning"
      >
        Вы можете сохранить изменения, создав новый сценарий или выйти без
        сохранения и тогда изменения будут утеряны. Сохранить изменения в новом сценарии?
      </div>

      <div class="row">
        <div class="col-xs-12">
          <ObInput
            v-model="saveScenarioInputs.title"
            :required="true"
            label="Название нового сценария"
            placeholder="Укажите здесь название нового сценария"
            @input="onInputTitle"
          />
        </div>
      </div>

      <div class="row">
        <div class="col-xs-12">
          <ObTextarea
            v-model="saveScenarioInputs.description"
            :required="true"
            label="Краткое описание"
            placeholder="Укажите здесь основные особенности расчета сценария"
          />
        </div>
      </div>

      <div class="save-modal-controls">
        <ObButton
          label="Сохранить"
          :disabled="isSaveDisabled"
          @click="onSaveScenario"
        />

        <ObButton
          label="Отменить"
          type="flat"
          @click="cancelQuit"
        />

        <ObButton
          v-if="isGoingToQuit"
          label="Выйти без сохранения"
          type="flat"
          @click="goToScenarios"
        />
      </div>
    </div>
  </ObModal>
</template>

<script>
  import api from "@/api";
  import ScenarioModalMixin from "../mixins/scenarioModalMixin";
  import ObInput from "common-components/src/obComponents/obInput";
  import ObButton from "common-components/src/obComponents/obButton";
  import ObTextarea from "common-components/src/obComponents/obTextarea";
  import { mapActions } from "vuex";

  export default {
    name: "tender-scenario-save-modal",
    mixins: [
      ScenarioModalMixin
    ],
    components: {
      ObInput,
      ObButton,
      ObTextarea
    },
    props: {
      tenderUuid: {
        type: String,
        required: true
      },
      scenarioUuid: {
        type: String,
        required: true
      }
    },
    data () {
      return {
        isGoingToQuit: false,
        saveScenarioInputs: {
          title: "",
          description: ""
        }
      }
    },
    computed: {
      title: ({ isGoingToQuit }) => isGoingToQuit ? "В сценарий были внесены изменения" : "Сохранение нового сценария",
      isSaveDisabled: ({ saveScenarioInputs }) => Object.values(saveScenarioInputs).some(value => !value),
    },
    methods: {
      ...mapActions({
        getScenario: "tendersScenario/getScenario",
        getOptions: "tendersScenario/getOptions"
      }),
      open(isFromBackButton = false) {
        this.isGoingToQuit = isFromBackButton;

        this.$refs.modal.open();
      },
      async onSaveScenario() {
        const payload = this.saveScenarioInputs;

        await api.tendersScenarios.saveTenderScenarioByUuids(this.tenderUuid, this.scenarioUuid, payload);

        const data = {
          tenderUuid: this.tenderUuid,
          scenarioUuid: this.scenarioUuid
        };

        await this.getScenario(data);
        await this.getOptions(data);

        this.$notification({
          type: "snackbars",
          message: "Сценарий сохранен"
        })

        this.close();

        if (this.isGoingToQuit) {
          this.goToScenarios()
        }
      },
      cancelQuit() {
        this.close();

        this.isGoingToQuit = false;
      },
      onInputTitle(value) {
        this.$nextTick(() => {
          // https://oboz.myjetbrains.com/youtrack/issue/CMN-1093
          this.saveScenarioInputs.title = value.slice(0, 57).replace(/[/\\|:*?"<>]/gi, "_");
        })
      },
      goToScenarios() {
        this.$emit("go-to-scenarios");
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .save-modal-warning {
    @include font-mixin(14px, 18px, 400, $tendersPage-save_modal_warn);
  }

  .save-modal-controls {
    display: flex;
    margin-top: 40px;

    button {
      &:nth-child(2) {
        margin-left: 20px;
      }

      &:nth-child(3) {
        margin-left: auto;
      }
    }
  }
</style>